﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Forms;  // MessageBox
using System.Data;
using FirebirdSql.Data.FirebirdClient;

namespace db2
{
    class Dbs
    {
        FbConnection _cnn;

        public void setDbs(string sDatabaseFile)
        {
            // Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            string sPath;
            sPath = Environment.CurrentDirectory;
            //sPath = "C:\\Daten";
            if (!sPath.EndsWith("\\")) sPath += "\\";
            string sArg =
                "User=SYSDBA;" +
                "Password=masterkey;" +
                "Database=" + sDatabaseFile + ";" +
                "DataSource=localhost;" +
                "Port=3050;" +
                "Dialect=3;" +
                "Charset=NONE;" +
                "Role=;" +
                "Connection lifetime=15;" +
                "Pooling=true;" +
                "MinPoolSize=0;" +
                "MaxPoolSize=50;" +
                "Packet Size=8192;" +
                "ServerType=1";

            if (_cnn != null)
            {
                //if (_cnn.Close();  // pro Forma
            }
            _cnn = new FbConnection(sArg);
            if (_cnn == null)
                MessageBox.Show("Fehler beim Öffnen der Datenbank\r\n" +
                      sPath + sDatabaseFile, "Fehler");
            else
                _cnn.Open();
        }  // dbs

        //_dbs.createDatabase("C:\\Daten\\test1.fdb");
        public void createDatabase(string sFilename)
        {
            string sArg =
                "User=SYSDBA;" +
                "Password=masterkey;" +
                "Database=" + sFilename + ";" +
                "DataSource=localhost;" +
                "Port=3050;" +
                "Dialect=3;" +
                "Charset=NONE;" +
                "Role=;" +
                "Connection lifetime=15;" +
                "Pooling=true;" +
                "MinPoolSize=0;" +
                "MaxPoolSize=50;" +
                "Packet Size=8192;" +
                "ServerType=1";

            FbConnection.CreateDatabase(sArg);
            // Alterbnative Parameter
            //FbConnection.CreateDatabase(connectionstring, pagesize, forcedwrite, overwrite
        }

        public void Close()
        {
            _cnn.Close();
        }

        public DataTable GetSchema(string sItem, string[] filter)
        {
            return _cnn.GetSchema(sItem, filter);
        }

        public DataTable getDBSData(string sSQL)
        {
            FbDataAdapter da = new FbDataAdapter(sSQL, _cnn);
            DataTable dt = new DataTable("RELATIONS");
            da.Fill(dt);
            da.Dispose();
            return dt;
        }



    }
}
